----------------------------------------------------------
--	Addon: 		    Bang! Core              			--
--	Description:    Provides Functions for Bang!Addons  --
--                                                      --
--	Author:		    Bangerz of Jubei'Thos (Oceanic)     --
--	Website:        BangCraft.com                       --
--  Email:          Bangerz@BangCraft.com               --
--  Credit To:      Shark, KaptainObvious, Tripole      --
--  Thanks To:      All our supporters and testers      --
--                                                      --
--  Release Build:  3.10.11                             --
--	                                                    --
--  Copyright 2008-2009 BangCraft, All Rights Reserved  --
--	                                                    --
----------------------------------------------------------
--[[
This is the new 3.1 BangCore_TPO, it manages version control and loading output for all Bang! addons, plus any others that choose to hook into it.
--]]

BangCore_TPO  = LibStub("AceAddon-3.0"):NewAddon("BangCore_TPO", "AceEvent-3.0", "AceConsole-3.0", "AceComm-3.0", "AceTimer-3.0")
local self = BangCore_TPO
local optionsFrame4
local addonname = "BangCore_TPO"
local addonversion = 31011

function BangCore_TPO:OnEnable()
    BangCore_TPO:RegisterEvent("CHAT_MSG_ADDON")
    BangCore_TPO:RegisterEvent("PARTY_MEMBERS_CHANGED")
end

function BangCore_TPO:LoadAddon(addonname, addonversion)
	if addonname == "BangCore_TPO" and (self.db.profile.ShowText) and select(4, _G.GetBuildInfo()) <= addonversion then
        DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00[B!Core]:|r For more great addons or the latest updates visit |cFFFFFF00BangCraft.com|r")
    elseif (select(4, _G.GetBuildInfo()) > addonversion) and self.db.profile.VersionWarn then
        DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00[B!Core]: It looks like addon '"..addonname.."' is seriously out of date, download the latest at |cFFFFFF00BangCraft.com|r")
    end
    self.db.profile.InstalledAddons = self.db.profile.InstalledAddons or { }
    self.db.profile.UpdatedAddons = self.db.profile.UpdatedAddons or { }
    self.db.profile.OutdatedAddons = self.db.profile.OutdatedAddons or { }
	if self.db.profile.InstalledAddons[addonname] then
		if addonversion > self.db.profile.InstalledAddons[addonname] then
			 self.db.profile.UpdatedAddons[addonname] = 200
			 self.db.profile.OutdatedAddons[addonname] = nil
	    end
	end
	self.db.profile.InstalledAddons[addonname] = addonversion
end

function BangCore_TPO:VersionCheck()
if not self.db.profile.notifyupdates then return end
    for i,v in pairs(self.db.profile.OutdatedAddons) do
        if v ~= nil then
           DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00[BCore]:|r There are updates available! To view them type /bcore update.");
		   break;
        end
    end
end

function BangCore_TPO:PARTY_MEMBERS_CHANGED(...)
if self.db.profile.paranoid then return end
BC_AC_Throttle = BC_AC_Throttle or -3
if BC_AC_Throttle > GetTime() then return else BC_AC_Throttle = GetTime() + 600; end
	for index,v in pairs (self.db.profile.UpdatedAddons) do
		if v ~= nil then
	    	if UnitExists("party1") then SendAddonMessage("BangCore_TPO", index.." "..self.db.profile.InstalledAddons[index], "PARTY"); end
			if UnitExists("raid1") then SendAddonMessage("BangCore_TPO", index.." "..self.db.profile.InstalledAddons[index], "RAID"); end
			if (GetNumBattlefieldStats() > 1) then SendAddonMessage("BangCore_TPO", index.." "..self.db.profile.InstalledAddons[index], "BATTLEGROUND"); end
			if IsInGuild() then SendAddonMessage("BangCore_TPO", index.." "..self.db.profile.InstalledAddons[index], "GUILD") end
			self.db.profile.UpdatedAddons[index] = self.db.profile.UpdatedAddons[index] - 1
	    	if self.db.profile.UpdatedAddons[index] < 2 then self.db.profile.UpdatedAddons[index] = nil end
	    end
	end
end

function BangCore_TPO:CHAT_MSG_ADDON(...)
	local sender,channel,fullm,prefix,eventmsg  = select(5,...),select(4,...),select(3,...),select(2,...),select(1,...)
	  if prefix == "BangCore_TPO" and (fullm) then
	  local split = BangCore_TPO:Split(fullm, " ")
	  local message = split[1]
	  local mcode = split[2]
	  for index,v in pairs (self.db.profile.InstalledAddons) do
  	   	if v ~= nil then
		  if tostring(message)== tostring(index) then
		    if self.db.profile.InstalledAddons[index] < tonumber(mcode) then
                self.db.profile.OutdatedAddons = self.db.profile.OutdatedAddons or { }
				self.db.profile.OutdatedAddons[index] = tonumber(mcode)
				break
			end
		  end
  	   	end
  	   end
	end
end

-- This function was adapted from the luaforge website.
function BangCore_TPO:Split(str, delim, maxNb)
    if string.find(str, delim) == nil then
        return { str }
    end
    if maxNb == nil or maxNb < 1 then
        maxNb = 0
    end
    local result = {}
    local pat = "(.-)" .. delim .. "()"
    local nb = 0
    local lastPos
    for part, pos in string.gmatch(str, pat) do
        nb = nb + 1
        result[nb] = part
        lastPos = pos
        if nb == maxNb then break end
    end
    if nb ~= maxNb then
        result[nb + 1] = string.sub(str, lastPos)
    end
    return result
end

function BangCore_TPO:ChatCommand(input)
if InCombatLockdown() then DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00[B!Core]: In Combat."); return end
local weekday,month,day,year=CalendarGetDate()
	if not input or input:trim() == "" then
		InterfaceOptionsFrame_OpenToCategory("BangCore_TPO")
	else
		if input == "version" then
		    for i,v in pairs(self.db.profile.InstalledAddons) do
		        if v ~= nil then
		            DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00"..i..": v"..v.."|r is installed.")
		        end
		    end
        elseif input == "update" then
		    for i,v in pairs(self.db.profile.OutdatedAddons) do
		        if v ~= nil then
		            DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00"..i..": v"..self.db.profile.InstalledAddons[i].."|r is outdated. v "..v.." is available.")
		        end
		    end
		    DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00[B!Core]:|r No futher updates known.")
		elseif input == "noty" then
			self.db.profile.stfu=true
			DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00[B!Core]: Is a very sad panda =(")
		elseif input == "clearlist" then
		    self.db.profile.InstalledAddons = nil
		    self.db.profile.UpdatedAddons = nil
		    self.db.profile.OutdatedAddons = nil
  		end
	end
end

function BangCore_TPO:OnInitialize()
local weekday,month,day,year=CalendarGetDate()
local defaults = {
   	      profile = {
			 ShowText=true,
             VersionWarn=true,
             notifyupdates=true,
             stfu=false,
             paranoid=false,
                    }
 	             }
  local options5 = {
    type="group",
    name = "Bang! Core",
    childGroups = "tab",
    plugins = {},
    args = {
     	Lodontspam= {
		type = "toggle",
		name = "Show Startup Text",
	 	desc = "I am deeply hurt that you could possibly wish to hide this awesome text, I mean, its got colours and stuff. But I guess you can if you must :(",
	 	width="full",
        get=function() return self.db.profile.ShowText end,
        set=function(info, value) self.db.profile.ShowText=value end,
    	order=6,
    	},
        notify= {
		type = "toggle",
		name = "Tell me when I log in if any updates have been seen",
	 	desc = "This toggles BangCore_TPO's update feature, get notified when someone else has a newer version than you! Requires 'Sync Version Data'",
	 	width="full",
        get=function() return self.db.profile.notifyupdates end,
        set=function(info, value) self.db.profile.notifyupdates=value; if self.db.profile.paranoid then self.db.profile.notifyupdates=false; end end,
    	order=8,
    	},
        noverwarn= {
		type = "toggle",
		name = "Auto-warn if an addon is seriously out-of-date",
	 	desc = "I wouldnt turn this off, it only fires when an addon is a MAJOR patch out of date.",
	 	width="full",
        get=function() return self.db.profile.VersionWarn end,
        set=function(info, value) self.db.profile.VersionWarn=value end,
    	order=10,       
                 },
        paranoidmuch= {
		type = "toggle",
		name = "Sync version data",
	 	desc = "This sends notifications of updates to other users via the addon channel.",
	 	width="full",
        get=function() return not self.db.profile.paranoid end,
        set=function(info, value) self.db.profile.paranoid= not value; if self.db.profile.paranoid then self.db.profile.notifyupdates=false; end end,
    	order=15,
        },
		rofllez = {
		type = "description",
		name =  "  ",
    	order=28,
                },			
		roflle = {
		type = "description",
		name =  "Blizzard says that I can't tell you to push this button. So, please click very close to this button rather innacurately.",
    	order=30,
                }, 	
    	 listversions = {
		type = "execute",
		name = "Oh No You Didnt!",
	 	desc = "Or did you?",
        func=function() BangCore_TPO:GFU("Ilikeicecream"); end,
    	order=50,
                 },						
            },
			}
	
    self:RegisterChatCommand("bcore", "ChatCommand")
    self:RegisterChatCommand("BangCore_TPO", "ChatCommand")
 	self.db = LibStub("AceDB-3.0"):New("BangCore_TPODB", defaults, "Default")
    LibStub("AceConfig-3.0"):RegisterOptionsTable("BangCore_TPO", options5)
    optionsFrame4 = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("BangCore_TPO", "BangCore_TPO")
    self.db.profile.Pushed=self.db.profile.Pushed or BangCore_TPO:Timestamp("days")
 	BangCore_TPO:LoadAddon(addonname, addonversion)
	BangCore_TPO:GFU("Ilikewaffles")
    BangCore_TPO:VersionCheck()
end

function BangCore_TPO:Timestamp(type)
	local weekday,month,day,year=CalendarGetDate()
	local hours, minutes = GetGameTime()
	local mmonth = ""..month..""
	local mday = ""..day..""
	local mhours = ""..hours..""
	local mminutes =""..minutes..""
	if #mmonth 		<= 1 then month = "0"..month end
	if #mday 		<= 1 then day = "0"..day end
	if #mhours 		<= 1 then hours = "0"..hours end
	if #mminutes	<= 1 then minutes = "0"..minutes end
    local timestamp
	if type == "date" then
	  timestamp = year.." "..month.."/"..day
	elseif type == "days" then
	   timestamp = day + (month*30) + (year*365) + (hours/24) +(minutes/(24*60))
	else
	  timestamp = year.." "..month.."/"..day.." "..hours..":"..minutes
	end
	return timestamp
end

function BangCore_TPO:GFU(input)
local weekday,month,day,year=CalendarGetDate()
		if input == "Ilikeicecream" then self.db.profile.Pushed=BangCore_TPO:Timestamp("days"); DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00BangCraft.com|r - The makers of all the Bang! addons that we hope you enjoy - is 100% supported by the love and donations of the addon user community. Please feel free to visit the website for a completely unrelated reason and accidentally click the big green button - Your miss-clicks keep the website alive! ;)");
		elseif input == "Ilikewaffles" and tonumber(self.db.profile.Pushed-20) > tonumber(BangCore_TPO:Timestamp("days")) and (not self.db.profile.stfu) then self.db.profile.Pushed=BangCore_TPO:Timestamp("days"); DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00BangCraft.com|r is supported only by the love and donations of the addon user community. Please consider making a contribution if you enjoy our addons - even a couple of dollars is greatly appreciated :). This monthly reminder can be be disabled with /bcore noty.");
		end
end




