----------------------------------------------------------
--	Addon: 		    Bang! Wintergrasp                	--
--	Description:    Shows time to next WG Battle     	--
--                  Who Attacks/Defends                 --
--					Syncs with other addon-users  		--
--                  Saves data between log-outs         --
--					Ultimate Auto-form raid group 		--
--                                                      --
--	Author:		    Bangerz of Jubei'Thos (Oceanic)     --
--                                                      --
--	Website:        BangCraft.com                       --
--  Release Build:  3.10.16                             --
--	                                                    --
--  DataBroker      Enable in menu                      --
--  Slash Command:  /bwg (menu)                         --
--	Chat Request:   "!WG" in Guild or Whisper           --
--	Chat Reminders: Enable in menu                      --
--	Hotkey:			Defined Under 'Hotkeys'             --
--														--
--  Localization    Partial German (Thanks Runkel)      --
--                                                      --
--  Copyright 2008-2009 BangCraft, All Rights Reserved  --
--	                                                    --
--	                                                    --
----------------------------------------------------------

BangWintergraspFrame = CreateFrame("frame")
BangWintergrasp = LibStub("AceAddon-3.0"):NewAddon("BangWintergrasp", "AceEvent-3.0", "AceConsole-3.0", "AceTimer-3.0")
local self = BangWintergrasp
local optionsFrame
local addonversion = 30116
local addonname = "BangWintergrasp"
local _G              	 		= getfenv(0)
local GetTime            		= _G.GetTime
local UnitExists           		= _G.UnitExists
local UnitName           		= _G.UnitName
local GetWintergraspWaitTime    = _G.GetWintergraspWaitTime
local ipairs          			= _G.ipairs
local pairs            			= _G.pairs
local select           			= _G.select
local string           			= _G.string
local table            			= _G.table
local BWGOADS,BWGDontSyncYet,BWGGuildspam,BWGWspam,BWGController,WGBattleIn,bwgfullannounce,bwgknum,BWGShowpop,BWGChatRemind

function BangWintergrasp:slashHandler(input)
	if input=="debug" then
		self.db.profile.SyncShow=true
	elseif input =="debugoff" then
	    self.db.profile.SyncShow=false
	elseif input =="menu" then
		InterfaceOptionsFrame_OpenToCategory("BangWintergrasp")
	elseif input =="invite" then
  		BWGWhoInviteActive = true
        BWGInviteBlacklist.blacklisted={ }
		BangWintergrasp:WhoControl()
		ConvertToRaid();
    elseif input =="stop" then
  		BWGWhoInviteActive = false
    elseif input =="filteroff" then
  		self.db.profile.HoldFilter = true  		
    elseif input =="filter" then
  		self.db.profile.HoldFilter = false  
    elseif tonumber(input) ~= nil then
		if (tonumber(input) > 0 ) and self.db.profile.BangWintergraspCountdown then
			if (BangWintergraspGetZone == "Dalaran") and BWGWhoInviteActive then
   		       	SendChatMessage("Wintergrasp starts in "..self.db.profile.BangWintergraspCountdown..". PST for invite.", "CHANNEL", nil, tonumber(input))	
   		    else
   		        SendChatMessage("Wintergrasp starts in "..self.db.profile.BangWintergraspCountdown..".", "CHANNEL", nil, tonumber(input))
   		    end
		end      
	end
end
function BangWintergrasp:SetGlobalEnabled()
	if (self.db.profile.GlobalEnabled) then
		self.db.profile.GlobalEnabled = false
		BangWintergraspGlobalSyncOn=false
		LeaveChannelByName("bangwgsync")
	else
		self.db.profile.GlobalEnabled = true
		BangWintergrasp:ScheduleTimer("JoinGlobalSync", 15)
		for i=1,10,1 do
			RemoveChatWindowChannel(i, "bangwgsync")
		end
	end
end
function BangWintergrasp:JoinGlobalSync()
	BangWintergraspGlobalSyncOn=true
	JoinChannelByName("bangwgsync")
	for i=1,10,1 do
		RemoveChatWindowChannel(i, "bangwgsync")
	end
end
local function BangWintergraspFilter(eventframeself, event, ...)
	if self.db.profile.HoldFilter then return end
	local msg = string.lower(tostring(arg1))
	local BangWintergraspGetZone = (select(1,GetMapInfo()))
	if BWGWhoInviteActive then BangWintergraspGetZone="LakeWintergrasp" end
	if msg~=nil then
		if select(9, ...) == "bangwgsync"  then return true
		elseif string.find(msg,"do not disturb") and ((BangWintergraspGetZone == "LakeWintergrasp") or (BWGWhoInviteActive and BangWintergraspGetZone == "Dalaran")) then return true
		elseif string.find(msg,"is away from keyboard") and ((BangWintergraspGetZone == "LakeWintergrasp") or (BWGWhoInviteActive and BangWintergraspGetZone == "Dalaran")) then return true
		elseif string.find(msg,"level 80") and ((BangWintergraspGetZone == "LakeWintergrasp") or (BWGWhoInviteActive and BangWintergraspGetZone == "Dalaran")) then return true
	    elseif string.find(msg,"invite") and (BangWintergraspGetZone == "LakeWintergrasp")  or (BWGWhoInviteActive and BangWintergraspGetZone == "Dalaran") then return true
	    elseif string.find(msg,"has joined the raid") and ((BangWintergraspGetZone == "LakeWintergrasp") or (BWGWhoInviteActive and BangWintergraspGetZone == "Dalaran"))  then return true
	    elseif string.find(msg,"declines your group") and ((BangWintergraspGetZone == "LakeWintergrasp") or (BWGWhoInviteActive and BangWintergraspGetZone == "Dalaran")) then return true
	    elseif string.find(msg,"to join your") and ((BangWintergraspGetZone == "LakeWintergrasp")  or (BWGWhoInviteActive and BangWintergraspGetZone == "Dalaran")) then return true
	    elseif string.find(msg,"in a duel") and ((BangWintergraspGetZone == "LakeWintergrasp")  or (BWGWhoInviteActive and BangWintergraspGetZone == "Dalaran")) then return true
		elseif string.find(msg,"is already in a group") and ((BangWintergraspGetZone == "LakeWintergrasp") or (BWGWhoInviteActive and BangWintergraspGetZone == "Dalaran")) then return true
	    elseif string.find(msg,"missed yours") and ((BangWintergraspGetZone == "LakeWintergrasp") or (BangWintergraspGetZone == "Dalaran")) then return true
		elseif string.find(msg,"players found") and ((BangWintergraspGetZone == "LakeWintergrasp") or (BangWintergraspGetZone == "Dalaran")) then return true
		elseif (string.find(msg," players total")  or string.find(msg,"players total") or string.find(msg,"player total")) and ((BangWintergraspGetZone == "LakeWintergrasp") or (BangWintergraspGetZone == "Dalaran")) then return true
		elseif string.find(msg,"battle raid going out") and ((BangWintergraspGetZone == "LakeWintergrasp") or (BangWintergraspGetZone == "Dalaran")) then return true
		end
	end
end
function BangWintergrasp:LeaderChat(msg,author,channame)
	if channame == "bangwgsync" and  self.db.profile.GlobalEnabled and msg=="Leader" then
		self.db.profile.CurrentLeader=author
		if self.db.profile.CurrentLeader~=UnitName("player") then BangWintergrasp:CancelAllTimers() end
	elseif channame == "bangwgsync" and  self.db.profile.GlobalEnabled and msg=="WhoIsIt" and self.db.profile.CurrentLeader==UnitName("player") and (not(GetNumRaidMembers() > 37)) then
		id, name = GetChannelName("bangwgsync");
		if (id > 0 and name ~= nil) then
		    SendChatMessage("Leader", "CHANNEL", nil, GetChannelName("bangwgsync"))
		end
	end
end
function BangWintergrasp:CHAT_MSG_CHANNEL(aevn, msg, author, language, fullchan, target, tag, zoneID, channum, channame)
	BangWintergrasp:InviteG(msg,author,channame)
	BangWintergrasp:LeaderChat(msg,author,channame)
	if not (BangWintergraspGlobalSyncOn) or not self.db.profile.TimeTillWGB then return end
	if channame == "bangwgsync" and ((self.db.profile.TimeTillWGB-GetTime()) < 9001) and  self.db.profile.GlobalEnabled and (tonumber(msg) ~= nil) and (self.db.profile.Enabled) then
       if msg =="Alliance" then BWGController="Alliance" 
	   elseif msg =="Horde" then BWGController="Horde" 
	   elseif msg=="NeedTime" then
	     local sendtime =  self.db.profile.TimeTillWGB-GetTime()
	   	 SendAddonMessage("BangWG6", sendtime, "WHISPER", author)
		 if BWGController=="Alliance" or BWGController=="Horde" then
		    if self.db.profile.GlobalEnabled then
				id, name = GetChannelName("bangwgsync");
				if (id > 0 and name ~= nil) then
	    		    SendChatMessage(BWGController, "CHANNEL", nil, GetChannelName("bangwgsync"))
				end
			end
		 	if UnitExists("party1") then SendAddonMessage("BangWG5", BWGController, "PARTY") end
		 	if UnitExists("raid1")  then SendAddonMessage("BangWG5", BWGController, "RAID")  end
		 	if IsInGuild()          then SendAddonMessage("BangWG5", BWGController, "GUILD") end
	     end
	   end
	end                                      
end
function BangWintergrasp:PLAYER_ENTERING_WORLD()
    if self.db.profile.TimeTillWGB  then
    	if self.db.profile.TimeTillWGB < (GetTime()-1800) then
       	   self.db.profile.TimeTillWGB = (GetTime() + 999999)
       	   self.db.profile.BWGControllerS = "?"
       	elseif self.db.profile.BWGControllerS then
       	   BWGController = self.db.profile.BWGControllerS
		end
	else
        self.db.profile.TimeTillWGB = (GetTime() + 999999)
	end
	if GetWintergraspWaitTime() and GetWintergraspWaitTime()~=nil then
		if (self.db.profile.TimeTillWGB-GetTime()) > GetWintergraspWaitTime() then
	    	self.db.profile.TimeTillWGB  = (GetWintergraspWaitTime() + GetTime())
		end
 	end
 	if ((self.db.profile.TimeTillWGB-GetTime()) > 9901) then
		if self.db.profile.GlobalEnabled then
			id, name = GetChannelName("bangwgsync");
			if (id > 0 and name ~= nil) then
    		    SendChatMessage("NeedTime", "CHANNEL", nil, GetChannelName("bangwgsync"))
			end
		end
	end
end
function BangWintergrasp:OnEnable()
	BINDING_HEADER_BangWintergrasp= "Bang! Wintergrasp"
	BINDING_NAME_TOGGLE_BWG = "Show time until next battle"
	BangWintergrasp:RegisterEvent("PLAYER_ENTERING_WORLD")
    BangWintergrasp:RegisterEvent("PARTY_MEMBERS_CHANGED")
	BangWintergrasp:RegisterEvent("CHAT_MSG_ADDON")
	BangWintergrasp:RegisterEvent("CHAT_MSG_GUILD")
	BangWintergrasp:RegisterEvent("CHAT_MSG_WHISPER")
	BangWintergrasp:RegisterEvent("CHAT_MSG_SAY")
	BangWintergrasp:RegisterEvent("CHAT_MSG_CHANNEL")
    BangWintergrasp:RegisterEvent("GOSSIP_SHOW")
    ChatFrame_AddMessageEventFilter("CHAT_MSG_WHISPER_INFORM", BangWintergraspFilter)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_WHISPER", BangWintergraspFilter)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_SYSTEM", BangWintergraspFilter)
    ChatFrame_AddMessageEventFilter("CHAT_MSG_CHANNEL", BangWintergraspFilter)
    ChatFrame_AddMessageEventFilter("CHAT_MSG_SAY", BangWintergraspFilter)
	BangWintergraspFrame:SetScript("OnUpdate", function() BangWintergrasp:Update(arg1) end)
	BWGInviteBlacklist = { }
	BWGDontSyncYet,BWGGuildspam,BWGWspam,BWGController,WGBattleIn=GetTime(),1,1,"?",999999
    self.db.profile.TimeTillWGB = self.db.profile.TimeTillWGB or 999999
	self.db.profile.CurrentLeader="?"
	BWGShowpop=true
	if (self.db.profile.GlobalEnabled) then
		BangWintergrasp:ScheduleTimer("JoinGlobalSync", 15)
	else
		BangWintergraspGlobalSyncOn=false
		LeaveChannelByName("bangwgsync")
	end
    if IsAddOnLoaded("!Bang!Core-3.1") then BangCore_TPO:LoadAddon("[B!WG]", addonversion); else
		DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00[B!WG] Activated.|r (/bwg) For more great addons visit |cFFFFFF00BangCraft.com|r")
	end
	BangWintergrasp:DataBroker()
	StaticPopupDialogs["POP_WHOINVITE"] = {
    text = "Activate Wintergrasp Zone Invites?",
    button1 = "Yes",
    button2 = "No",
    OnAccept = function()
	  BangWintergrasp:DoPopFunc()
    end,
    timeout = 0,
    whileDead = 1,
    hideOnEscape = 1
   };
end
function BangWintergrasp:GOSSIP_SHOW()
	local text = GetGossipText()
	local englishFaction, localizedFaction = UnitFactionGroup("player")
	local BangWintergraspTimeFromNPC = findpattern(text, "%d:%d%d:%d%d")
	if     string.find(text, "When the Alliance controls Wintergrasp")  or string.find(text, "Wenn die Allianz die Tausendwinterfestung kontrolliert") then BWGController = "Horde";
	elseif string.find(text, "When the Horde controls Wintergrasp") or string.find(text, "Wenn die Horde die Tausendwinterfestung kontrolliert")       then BWGController = "Alliance";
	elseif string.find(text, "Use the portal")                          then BWGController = ""..englishFaction.."";
    end
	if BWGController~="?" then
	    if self.db.profile.GlobalEnabled then
			id, name = GetChannelName("bangwgsync");
			if (id > 0 and name ~= nil) then
    		    SendChatMessage(BWGController, "CHANNEL", nil, GetChannelName("bangwgsync"))
			end
		end
	 if UnitExists("party1") then SendAddonMessage("BangWG5", BWGController, "PARTY") end
	 if UnitExists("raid1")  then SendAddonMessage("BangWG5", BWGController, "RAID")  end
	 if IsInGuild()          then SendAddonMessage("BangWG5", BWGController, "GUILD") end
	end
end
function findpattern(text, pattern, start)
	if (text) then
	if string.find(text, pattern, start)then
	return string.sub(text, string.find(text, pattern, start)) end end
end
function BangWintergrasp:CHAT_MSG_WHISPER(aceevent, message, author, language)
    BangWintergrasp:InviteW(message,author)
	if ((message=="!WG")or(message=="!wg")) and (GetTime()>BWGWspam) and (self.db.profile.BangWintergraspCountdown) and (self.db.profile.Enabled) and (not(lastauthor == author)) and (self.db.profile.Allow) then
	    if (self.db.profile.BangWintergraspCountdown) and (self.db.profile.Enabled) and ((self.db.profile.TimeTillWGB-GetTime()) > -1800)  and ((self.db.profile.TimeTillWGB-GetTime()) < 90) then
			local sendthis = self.db.profile.BangWintergraspCountdown
			BWGWspam=GetTime()+0.8
            SendChatMessage("B!WG: The Battle is on! Download B!WG from BangCraft.com to instantly know the time until WG from anywhere.", "WHISPER", nil, author)
		elseif (self.db.profile.BangWintergraspCountdown) and (self.db.profile.Enabled) and ((self.db.profile.TimeTillWGB-GetTime()) < 9001) then
			local sendthis = self.db.profile.BangWintergraspCountdown
			if BWGController =="Alliance" or BWGController=="Horde" then
				SendChatMessage("B!WG: "..BWGController.." defend Wintergrasp in "..sendthis..". Download B!WG from BangCraft.com to instantly know the time until WG from anywhere.", "WHISPER", nil, author)
			else
				SendChatMessage("B!WG: Wintergrasp starts in "..sendthis..". Download B!WG from BangCraft.com to instantly know the time until WG from anywhere.", "WHISPER", nil, author)
			end
			BWGWspam=GetTime()+0.8
		else
    	    local sendthis = "???"
    	end
	end
end
function BangWintergrasp:CHAT_MSG_GUILD(aceevent, message, author, language)
if not (self.db.profile.Master) then return end
	if ((message=="!WG")or(message=="!wg")) and (self.db.profile.Enabled) and (GetTime()>BWGGuildspam) and(self.db.profile.BangWintergraspCountdown) and (not(lastauthor == author)) and (self.db.profile.Allow) then
	    if (self.db.profile.BangWintergraspCountdown) and (self.db.profile.Enabled) and ((self.db.profile.TimeTillWGB-GetTime()) > -1800)  and ((self.db.profile.TimeTillWGB-GetTime()) < 90) then
			local sendthis = self.db.profile.BangWintergraspCountdown
            SendChatMessage("B!WG: The Battle is on!", "GUILD", nil) 
			BWGGuildspam=GetTime()+10
		elseif (self.db.profile.BangWintergraspCountdown) and (self.db.profile.Enabled) and ((self.db.profile.TimeTillWGB-GetTime()) < 9001) then
			local sendthis = self.db.profile.BangWintergraspCountdown
            if BWGController =="Alliance" or BWGController=="Horde" then
				SendChatMessage("B!WG: "..BWGController.." defend Wintergrasp in "..self.db.profile.BangWintergraspCountdown..".", "GUILD", nil)
			else
				SendChatMessage("B!WG: Wintergrasp starts in "..sendthis..".", "GUILD", nil)
			end
            BWGGuildspam=GetTime()+10
    	end
	end
end
function BangWintergrasp:SCTPlease()
	local BangWGsendmethewg="?"
	if  (self.db.profile.BangWintergraspCountdown) and (self.db.profile.Enabled) and  ((self.db.profile.TimeTillWGB-GetTime()) < 90)  and  ((self.db.profile.TimeTillWGB-GetTime()) > -1800) then
		  DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00[B!WG]: |rWintergrasp in: |cFFFF0000 Battle Is on!")
	elseif (self.db.profile.BangWintergraspCountdown) and (self.db.profile.Enabled) and ((self.db.profile.TimeTillWGB-GetTime()) < 9001) then
		if BWGController == "Alliance" or BWGController == "Horde" then DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00[B!WG]: |r"..BWGController.." defend Wintergrasp in: "..self.db.profile.BangWintergraspCountdown)
		else DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00[B!WG]: |rWintergrasp starts in: "..self.db.profile.BangWintergraspCountdown) end
	else
	    DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00[B!WG]: |r"..BWGController.." defend Wintergrasp in: |cFFFF0000???")
	end
	
	if  (self.db.profile.BangWintergraspCountdown) and (self.db.profile.Enabled) and  ((self.db.profile.TimeTillWGB-GetTime()) < 90)  and  ((self.db.profile.TimeTillWGB-GetTime()) > -1800) then
		   BangWGsendmethewg="WG: Battle is on!"
	elseif (self.db.profile.BangWintergraspCountdown) and (self.db.profile.Enabled) and ((self.db.profile.TimeTillWGB-GetTime()) < 9001) then
		 if BWGController == "Alliance" or BWGController == "Horde" then BangWGsendmethewg=BWGController.." defend WG in: "..self.db.profile.BangWintergraspCountdown
		 else BangWGsendmethewg= "WG starts in: "..self.db.profile.BangWintergraspCountdown end
	else
	     BangWGsendmethewg="WG: ???"
	end
   if (IsAddOnLoaded("MikScrollingBattleText")) then	MikSBT.DisplayMessage(BangWGsendmethewg,  nil, 1, 255, 1, 1, 80, nil, 5) end
   if (IsAddOnLoaded("Parrot"))then	Parrot:ShowMessage(BangWGsendmethewg, nil, 1, 255, 1, 1, 80, nil)  end
   if (IsAddOnLoaded("ScrollingCombatText"))  then	SCT:DisplayText(BangWGsendmethewg, {r = 1, g = 0, b = 0}, false, "event", 1, nil)    end
   if( IsAddOnLoaded("Blizzard_CombatText")) then CombatText_AddMessage(BangWGsendmethewg, COMBAT_TEXT_SCROLL_FUNCTION, 1, 0, 0) end
end
function BangWintergrasp:Update(elapsed)
	if not (zDelayTime) then zDelayTime = GetTime() end
    if (GetTime() > zDelayTime) and (self.db.profile.Enabled) then
    zDelayTime = GetTime() + 5
				if not BangWintergrasp.db.profile.TimeTillWGB  then     
				      BangWintergrasp:PLAYER_ENTERING_WORLD()
				      return
				elseif ((tonumber(BangWintergrasp.db.profile.TimeTillWGB)-GetTime()) > 9900) then
					  BangWintergrasp:PLAYER_ENTERING_WORLD() 
				      return
				elseif ((tonumber(BangWintergrasp.db.profile.TimeTillWGB)-GetTime()) < -60) and GetWintergraspWaitTime() then      
					if GetWintergraspWaitTime() > 6000 then self.db.profile.TimeTillWGB  = (GetWintergraspWaitTime() + GetTime()) end
				end
	            if ((tonumber(BangWintergrasp.db.profile.TimeTillWGB)-GetTime()) < -1800) then
               		 self.db.profile.TimeTillWGB = GetTime() +999999
               		 BWGController="?"
               		 self.db.profile.BWGControllerS = "?"
               		 bwgfullannounce=false
				end
	            WGBattleIn = (tonumber(self.db.profile.TimeTillWGB)-GetTime())
				if (tonumber(self.db.profile.TimeTillWGB)-GetTime()) > 61 then self.db.profile.BangWintergraspCountdown = BangWintergrasp:ClockFromSec(1.015*(tonumber(self.db.profile.TimeTillWGB)-GetTime())) end
				self.db.profile.BWGControllerS = BWGController
			    BWGChatRemind = BWGChatRemind or 0
                if (self.db.profile.Enabled) then
				    if (WGBattleIn > 7202)  then
                         BWGStartWarn=false
					elseif (WGBattleIn > 60) and (WGBattleIn < 7202) and ((GetTime() - BWGChatRemind) > 1800)then
						BWGChatRemind = GetTime()
						if (self.db.profile.Remind) and (not(GetRealZoneText()=="Wintergrasp")) then BangWintergrasp:ChatWG(sendthis) end
					elseif (WGBattleIn < 60) then
                   		 self.db.profile.BangWintergraspCountdown = 0
						 if (WGBattleIn > 0)  and (not BWGStartWarn) then
						 	 BWGStartWarn=true
							 if (self.db.profile.Remind) and (not(GetRealZoneText()=="Wintergrasp")) then DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00[B!WG]: |rWintergrasp is about to begin!")  end
							 if (self.db.profile.Master) then SendChatMessage("B!WG: Wintergrasp is about to begin!", "GUILD")  end
						 end
					end
               	end
			if BWGWhoInviteActive and ((tonumber(BangWintergrasp.db.profile.TimeTillWGB)-GetTime()) > 3002) and ((tonumber(BangWintergrasp.db.profile.TimeTillWGB)-GetTime()) < 8002) then
    	        DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00[B!WG]|r Zone invite scanning disabled.")
				BWGWhoInviteActive=false
				BWGInviteBlacklist={}
			end
			   BangWintergrasp:DataBroker()
    end
end
function BangWintergrasp:ChatWG()
			if BWGController =="Alliance" or BWGController=="Horde" then
				DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00[B!WG]|r "..BWGController.." defend Wintergrasp in "..self.db.profile.BangWintergraspCountdown..".")
			else
				DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00[B!WG]|r Wintergrasp starts in "..self.db.profile.BangWintergraspCountdown..".")
			end
end
function BangWintergrasp.ProcessTooltip(tooltip, name, link)
	if (self.db.profile.BangWintergraspCountdown) and IsAltKeyDown() and (self.db.profile.Tooltip) and (self.db.profile.Enabled) then
                GameTooltip:ClearLines()
				GameTooltip:AddLine(BWGController.." defend Wintergrasp in: "..self.db.profile.BangWintergraspCountdown, 0, 1, 0)
	        	GameTooltip:Show()
   	end
end
function BangWintergrasp:CHAT_MSG_ADDON(arg1, arg2, arg3, arg4, arg5)
	 if arg2 == "BangWG5" and (arg3=="Alliance" or arg3=="Horde") then
	    BWGController = arg3
	 elseif arg2 == "BangWG6" and arg5 ~= UnitName("player") and channel=="WHISPER" then
	   	if (    (not(self.db.profile.TimeTillWGB)) or  ((BangWintergrasp.db.profile.TimeTillWGB-GetTime())>9901) or ((BangWintergrasp.db.profile.TimeTillWGB-GetTime())< -1200)   ) and arg3 then
	       self.db.profile.TimeTillWGB=tonumber(arg3)+GetTime()
	    end
 		BangWintergrasp:DataBroker()
	end
end
function BangWintergrasp:ConvertSec(BangWintergraspVarTi, whichsentitwg)
	local BangWintergraspHours = tonumber((BangWintergraspVarTi:match(".")):match("."))
	local BangWintergraspMinutes = tonumber(BangWintergraspVarTi:match("%d%d"))
	local BangWintergraspSeconds = tonumber(BangWintergraspVarTi:gsub(".","",5))
	if(BangWintergraspHours==nil)then BangWintergraspHours=0 end;
	if(BangWintergraspMinutes==nil) then BangWintergraspMinutes=0 end;
	if(BangWintergraspSeconds==nil)then	BangWintergraspSeconds=0 end;
	if (BangWintergraspHours == 0)then
		if(BangWintergraspMinutes == 0)then	BangWintergraspSecondsTime = BangWintergraspSeconds
		else BangWintergraspSecondsTime = (BangWintergraspMinutes*60)+BangWintergraspSeconds end
	else BangWintergraspSecondsTime = (BangWintergraspHours*3600)+(BangWintergraspMinutes*60)+BangWintergraspSeconds; end
	BangWintergrasp:ClockFromSec(BangWintergraspSecondsTime)
	return BangWintergraspSecondsTime
end
function BangWintergrasp:ClockFromSec(BangWintergraspVarTi)
if not (BangWintergraspVarTi) then return end
	if((math.floor(BangWintergraspVarTi % 60)) < 10)then BangWintergraspClockTime = "0"..tostring(math.floor(BangWintergraspVarTi % 60))..""
    else BangWintergraspClockTime = tostring(math.floor(BangWintergraspVarTi % 60)).."" end
 if BangWintergraspVarTi >= 60 then
  	BangWintergraspVarTi = BangWintergraspVarTi / 60
        if((math.floor(BangWintergraspVarTi % 60)) < 10)then BangWintergraspClockTime = "0"..tostring(math.floor(BangWintergraspVarTi % 60))..":"..BangWintergraspClockTime
        else BangWintergraspClockTime = tostring(math.floor(BangWintergraspVarTi % 60))..":"..BangWintergraspClockTime end
		if BangWintergraspVarTi >= 60 then BangWintergraspVarTi = BangWintergraspVarTi / 60; BangWintergraspClockTime = tostring(math.floor(BangWintergraspVarTi % 24))..":"..BangWintergraspClockTime
        if BangWintergraspVarTi >= 24 then BangWintergraspVarTi = BangWintergraspVarTi / 24; BangWintergraspClockTime = tostring(math.floor(BangWintergraspVarTi)).."d"..BangWintergraspClockTime  end
        else BangWintergraspClockTime = "0:"..BangWintergraspClockTime end
    else BangWintergraspClockTime = "0:00:"..BangWintergraspClockTime  end
	return BangWintergraspClockTime
end
function BangWintergrasp:DataBroker()
	if not self.db.profile.DataBroker then return end
		if (self.db.profile.TimeTillWGB-GetTime()) < 90 then
            BWGDBText = "Battle on!"
		else
	    	BWGDBText = self.db.profile.BangWintergraspCountdown
		end
	local bwgdbmsg = "BWG "
	if self.db.profile.BangWintergraspCountdown then
	BWGDBString = "BWG: "..self.db.profile.BangWintergraspCountdown.." until the "..BWGController.." defend Wintergrasp."
	end
	if not BWGBroker then
	BWGBroker = LibStub("LibDataBroker-1.1"):NewDataObject(bwgdbmsg, {
	    type = "data source",
		text = BWGDBText,
		icon = "Interface\\Icons\\INV_Jewelry_Ring_66",
	    OnClick = function(self, button)
	        	if IsShiftKeyDown() then
	            	if button == "LeftButton" and BWGDBString then
	               	    BangWintergrasp:CHAT_MSG_GUILD("FAnnounce", "!WG", UnitName("player"), nil)
	            	elseif button == "RightButton" then

	            	end
	        	end
	    end,
	    OnEnter = function(self)
	        GameTooltip:SetOwner(self, "ANCHOR_NONE")
	        GameTooltip:SetPoint("TOPLEFT", self, "BOTTOMLEFT")
	        GameTooltip:ClearLines()
	        GameTooltip:AddLine(BWGDBString,0,1,0.2)
	        GameTooltip:Show()
	    end,
	    OnLeave = function()
	        GameTooltip:Hide()
	    end,
	})
	else
	    BWGBroker.text=BWGDBText
	end
end
function BangWintergrasp:OnInitialize()
   local defaults = {
   profile = {
   Enabled=true,
   Remind=true,
   DataBroker=true,
   APromoteOff=false,
   Tooltip=true,
   Attacker="?",
   AllowSync=true,
   GlobalEnabled=true,
   TimeTillWGB=(GetTime()+110800),
   Authors= { },
   }
   }
    options = {
    type="group",
    name = "Bang! Wintergrasp",
    childGroups = "tab",
    plugins = {},
    args = {

			enable = {
           		 type = "toggle",
           		 name = "Enabled",
           		 desc = "Enabled",
    		     get=function() return self.db.profile.Enabled end,
    	         set=function(i,v) self.db.profile.Enabled=v end,
                order=1,
              },
              	remind = {
           		 type = "toggle",
           		 name = "Chat Reminders",
           		 desc = "Remind Me about WG in chat",
    		     get=function() return self.db.profile.Remind end,
    	         set=function(info, value)self.db.profile.Remind=value end,
                order=2,
              },
--[[               tooltip = {
           		 type = "toggle",
           		 name = "Alt Tooltip",
           		 desc = "Hold Alt to show time to battle in most tooltips temporarily.",
    		     get=function() return self.db.profile.Tooltip end,
    	         set=function(info, value)self.db.profile.Tooltip=value end,
                order=3,
              }, --]]
               allowq = {
           		 type = "toggle",
           		 name = "Allow Queries",
           		 desc = "Allow others to ask you for the WG start time",
    		     get=function() return self.db.profile.Allow end,
    	         set=function(info, value)self.db.profile.Allow=value end,
                order=4,
              },

                 allowsc = {
           		 type = "toggle",
           		 name = "Use ServerWide Sync",
           		 desc = "Use the global sync channel (as opposed to contact sync only). This will result in more accurate syncing but will take up a chat channel slot.",
    		     get=function() return self.db.profile.GlobalEnabled end,
    	         set=function() BangWintergrasp:SetGlobalEnabled() end,
                order=5,
              },
              	master = {
           		 type = "toggle",
           		 name = "Guild Announce",
           		 desc = "More than one person using this is annoying.",
    		     get=function() return self.db.profile.Master end,
    	         set=function(info, value) self.db.profile.Master=value end,
                order=8,
              },
              dbroker = {
           		 type = "toggle",
           		 name = "Data Broker (Titan Panel plugins etc)",
           		 desc = "Enables Data Broker support",
           		 width="full",
    		     get=function() return self.db.profile.DataBroker end,
    	         set=function(info, value) self.db.profile.DataBroker=value; BangWintergrasp:DataBroker() end,
                order=9,
              },
              hewinvite = {
           		 type = "header",
           		 name = "Group Forming Functions",
           		 width="full",
           		 desc = "",
    		     get=function() return self.db.profile.WhisperInvite end,
    	         set=function(info, value) self.db.profile.WhisperInvite=value; end,
                order=13,
              },
             winvite = {
           		 type = "toggle",
           		 name = "Invite From Whispers (in WG)",
           		 width="full",
           		 desc = "Auto invite people who whisper you, active only in WG",
    		     get=function() return self.db.profile.WhisperInvite end,
    	         set=function(info, value) self.db.profile.WhisperInvite=value; end,
                order=14,
              },

             ginvite = {
           		 type = "toggle",
           		 name = "Invite From Global Channels (in WG)",
           		 width="full",
           		 desc = "Auto invite people from General, Local Defense, Say, Yell - Active only in WG",
    		     get=function() return self.db.profile.GlobalInvite end,
    	         set=function(info, value) self.db.profile.GlobalInvite=value; end,
                order=15,
              },

             einvite = {
           		 type = "toggle",
           		 name = "Remove WG Zone Restriction on Invites",
           		 width="full",
           		 desc = "Used for when you are forming a group in Dalaran... or whatever. Must be on to use Dalaran invite",
    		     get=function() return self.db.profile.EInvite end,
    	         set=function(info, value) self.db.profile.EInvite=value; end,
                order=16,
              },

              whoinvite = {
           		 type = "toggle",
           		 name = "|cFF00FF00[On Demand] |rAuto-Invite Entire Zone in WG",
           		 width="full",
           		 desc = "Yup. This will invite everyone in the entire zone if you have assist or are leader of a raid. The invites occur constantly throughout the whole battle. Requires ServerWideSync.",
    		     get=function() return self.db.profile.WhoInvite end,
    	         set=function(info, value) if self.db.profile.GlobalEnabled then self.db.profile.WhoInvite=value; else  self.db.profile.WhoInvite=false; end; end,
                order=17,
              },
               autowhoinvite = {
           		 type = "toggle",
           		 name = "|cFF00FF00[On Demand] |rSkip Auto-Invite Entire Zone in WG Confirmation",
           		 width="full",
           		 desc = "Used with above skips the confirmation popup. Careful with this!",
    		     get=function() return self.db.profile.AutoWho end,
    	         set=function(info, value) self.db.profile.AutoWho=value; self.db.profile.WhoInvite=true  end,
                order=18,
              },

                 dautowhoinvite = {
           		 type = "toggle",
           		 name = "|cFF00FF00[On Demand] |rEnable Pre-Battle Grouping in Dalaran. Talk to the NPC to activate",
           		 width="full",
           		 desc = "Will enable group forming functions before the battle, inviting everyone in the zone plus anyone who whispers. Activated by talking to the Wintergrasp portal NPC <20 minutes to battle. Requires Auto-Invite Entire Zone.",
    		     get=function() return self.db.profile.Dalaran end,
    	         set=function(info, value) self.db.profile.Dalaran=value; self.db.profile.EInvite=true; self.db.profile.WhoInvite=true end,
                order=19,
              },

                dotnaprom = {
           		 type = "toggle",
           		 name = "Dont Auto-Promote Raid",
           		 width="full",
           		 desc = "Disables the default of promoting all invitees.",
    		     get=function() return self.db.profile.APromoteOff end,
    	         set=function(info, value) self.db.profile.APromoteOff=value; end,
                order=21,
              },

         	   }, }
    self:RegisterChatCommand("bwg", "ChatCommand")
    self:RegisterChatCommand("BangWintergrasp", "ChatCommand")
 	self.db = LibStub("AceDB-3.0"):New("BangWintergraspDB", defaults, "Default")
    LibStub("AceConfig-3.0"):RegisterOptionsTable("BangWintergrasp", options)
    optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("BangWintergrasp", "BangWintergrasp")
end
function BangWintergrasp:ChatCommand(input)
    if not input or input:trim() == "" then
        BangWintergrasp:SCTPlease()
	else
        BangWintergrasp:slashHandler(input)
    end
end